#include <LiquidCrystal_I2C.h>
#include <SoftwareSerial.h>
#include <Wire.h> 
LiquidCrystal_I2C lcd(0x3F, 20, 4);


SoftwareSerial mySerial(2, 3); // RX, TX

byte resetMIDI = 4; //Tied to VS1053 Reset line
byte ledPin = 13; //MIDI traffic inidicator

int outputA = 12;
int outputB = 11;
int piezoPin = 50;
int echoPin = 9;
int trigPin = 8;
int encoder = 10;
int MODE = 0;
int KEY = 0;
int distance;
long duration;
int maxValue = 0;
int minValue = 1023;
float baseNote;
long intervals;
int notes[29];
int n;
int st;
long intervalsCopie;
long freq;
long freqcopy;
int counter = 0; 
int aState;
int aLastState;  


float findMod(float a, float b) {
    float mod = a;
    while (mod >= b)
        mod = mod - b;
    return mod;
}
void clearscreen(){
  
  lcd.setCursor(0, 2);
  lcd.print("                                                                   ");
  lcd.setCursor(2, 0);
  lcd.print("INTRODUCETI GAMA:");
  lcd.setCursor(0, 2);
}
void clearscreen2(){
  
  lcd.setCursor(0, 2);
  lcd.print("                                                                   ");
  lcd.setCursor(2, 0);
  lcd.print("INTRODUCETI MODUL:");
  lcd.setCursor(0, 2);
}

void setup() {
  lcd.begin();
  lcd.backlight();
  mySerial.begin(31250);

  
  pinMode(resetMIDI, OUTPUT);
  digitalWrite(resetMIDI, LOW);
  delay(100);
  digitalWrite(resetMIDI, HIGH);
  delay(100);
  talkMIDI(0xB0, 0x07, 120); 
  
  pinMode (outputA,INPUT);
  pinMode(encoder, INPUT_PULLUP);
  pinMode (outputB,INPUT);
  pinMode(echoPin, INPUT);
  pinMode(trigPin, OUTPUT); 
  pinMode(piezoPin, OUTPUT); 
  aLastState = digitalRead(outputA); 
  Serial.begin(9600);
    
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("WELCOME, FRIEND!");  //Se afiseaza primul mesaj pe ecranul LCD
  Serial.println("WELCOME, FRIEND!");
  delay(5000);
  lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("INTRODUCETI GAMA:");  //Se afiseaza cel de-al doilea mesaj pe ecranul LCD
  Serial.println("INTRODUCETI GAMA:");
  lcd.setCursor(0, 2);
  
  while (digitalRead(encoder)==HIGH) {   //Se verifica continuu starea butonului din encoder, astfel incat, la apasarea acestuia, sa se memoreze optiunea stabilita
    
    aState = digitalRead(outputA);
    if (aState != aLastState){
      if (digitalRead(outputB) != aState) { 
       counter ++;
      } 
      else {
       counter --;
      }
      switch(counter) {
          case -12: baseNote= 42; Serial.println("GAMA FA#"); clearscreen(); lcd.print("GAMA FA#"); break;
          case -10: baseNote= 43; Serial.println("GAMA SOL"); clearscreen(); lcd.print("GAMA SOL"); break;
          case -8: baseNote= 44; Serial.println("GAMA SOL#"); clearscreen(); lcd.print("GAMA SOL#"); break;
          case -6: baseNote= 45; Serial.println("GAMA LA"); clearscreen(); lcd.print("GAMA LA"); break;
          case -4: baseNote= 46; Serial.println("GAMA LA#"); clearscreen(); lcd.print("GAMA LA#"); break;
          case 0: baseNote= 47; Serial.println("GAMA SI"); clearscreen(); lcd.print("GAMA SI"); break;
          case 2: baseNote= 36; Serial.println("GAMA DO"); clearscreen(); lcd.print("GAMA DO"); break;
          case 4: baseNote= 37; Serial.println("GAMA DO#"); clearscreen(); lcd.print("GAMA DO#"); break;
          case 6: baseNote= 38; Serial.println("GAMA RE"); clearscreen(); lcd.print("GAMA RE"); break;
          case 8: baseNote= 39; Serial.println("GAMA RE#"); clearscreen(); lcd.print("GAMA RE#"); break;
          case 10: baseNote= 40; Serial.println("GAMA MI"); clearscreen(); lcd.print("GAMA MI"); break;
          case 12: baseNote= 41; Serial.println("GAMA FA"); clearscreen(); lcd.print("GAMA FA"); break;
          case 14: baseNote= 42; Serial.println("GAMA FA#"); clearscreen(); lcd.print("GAMA FA#"); break;
          case 16: baseNote= 43; Serial.println("GAMA SOL"); clearscreen(); lcd.print("GAMA SOL"); break;
          case 18: baseNote= 44; Serial.println("GAMA SOL#"); clearscreen(); lcd.print("GAMA SOL#"); break;
          case 20: baseNote= 45; Serial.println("GAMA LA"); clearscreen(); lcd.print("GAMA LA"); break;
          case 22: baseNote= 46; Serial.println("GAMA LA#"); clearscreen();lcd.print("GAMA LA#"); break;
          case 24: baseNote= 47; Serial.println("GAMA SI"); clearscreen(); lcd.print("GAMA SI"); break;
          case 26: baseNote= 36; Serial.println("GAMA DO"); clearscreen(); lcd.print("GAMA DO"); break;
          case 28: baseNote= 37; Serial.println("GAMA DO#"); clearscreen(); lcd.print("GAMA DO#"); break;
          case 30: baseNote= 38; Serial.println("GAMA RE"); clearscreen(); lcd.print("GAMA RE"); break;
          case 32: baseNote= 39; Serial.println("GAMA RE#"); clearscreen(); lcd.print("GAMA RE#"); break;
          case 34: baseNote= 40; Serial.println("GAMA MI"); clearscreen(); lcd.print("GAMA MI"); break;
      }
    } 
    aLastState = aState; 
  }
  
  KEY=counter;
  Serial.println(KEY);
  lcd.clear();
  delay(1000);
  aLastState = digitalRead(outputA);
  lcd.setCursor(2, 0);
  lcd.print("INTRODUCETI MODUL");   // Se afiseaza cel de-al treilea mesaj pe ecranul LCD
  Serial.println("INTRODUCETI MODUL");
  lcd.setCursor(0, 2);
  
  while (digitalRead(encoder)==HIGH) {  //Se verifica continuu starea butonului din encoder, astfel incat, la apasarea acestuia, sa se memoreze optiunea stabilita
    aState = digitalRead(outputA);
    if (aState != aLastState){
      if (digitalRead(outputB) != aState) { 
       counter ++;
      } 
      else {
       counter --;
      }
      switch(counter) {
          case -10: intervals= 1222122; Serial.println("PHRIGIAN"); clearscreen2(); lcd.print("PHRIGIAN"); break;
          case -8: intervals= 2221221; Serial.println("LIDIAN"); clearscreen2(); lcd.print("LIDIAN"); break;
          case -6: intervals= 2212212; Serial.println("MIXOLIDIAN"); clearscreen2(); lcd.print("MIXOLIDIAN"); break;
          case -4: intervals= 2122122; Serial.println("AEOLIAN"); clearscreen2(); lcd.print("AEOLIAN"); break;
          case -2: intervals= 1221222; Serial.println("LOCRIAN"); clearscreen2(); lcd.print("LOCRIAN"); break;
          case 0: intervals= 1312131; Serial.println("HUNGARIAN"); clearscreen2(); lcd.print("HUNGARIAN"); break;
          case 2: intervals= 2212221; Serial.println("IONIAN"); clearscreen2(); lcd.print("IONIAN"); break;
          case 4: intervals= 2122212; Serial.println("DORIAN"); clearscreen2(); lcd.print("DORIAN"); break;
          case 6: intervals= 1222122; Serial.println("PHRIGIAN"); clearscreen2(); lcd.print("PHRIGIAN"); break;
          case 8: intervals= 2221221; Serial.println("LIDIAN"); clearscreen2(); lcd.print("LIDIAN"); break;
          case 10: intervals= 2212212; Serial.println("MIXOLIDIAN"); clearscreen2(); lcd.print("MIXOLIDIAN"); break;
          case 12: intervals= 2122122; Serial.println("AEOLIAN"); clearscreen2(); lcd.print("AEOLIAN"); break;
          case 14: intervals= 1221222; Serial.println("LOCRIAN"); clearscreen2(); lcd.print("LOCRIAN"); break;
          case 16: intervals= 1312131; Serial.println("HUNGARIAN"); clearscreen2(); lcd.print("HUNGARIAN"); break;
          case 18: intervals= 2212221; Serial.println("IONIAN"); clearscreen2(); lcd.print("IONIAN"); break;
          case 20: intervals= 2122212; Serial.println("DORIAN"); clearscreen2(); lcd.print("DORIAN"); break;
          case 22: intervals= 1222122; Serial.println("PHRIGIAN"); clearscreen2(); lcd.print("PHRIGIAN"); break;
          case 24: intervals= 2221221; Serial.println("LIDIAN"); clearscreen2(); lcd.print("LIDIAN"); break;
          case 26: intervals= 2212212; Serial.println("MIXOLIDIAN"); clearscreen2(); lcd.print("MIXOLIDIAN"); break;
          case 28: intervals= 2122122; Serial.println("AEOLIAN"); clearscreen2(); lcd.print("AEOLIAN"); break;
          case 30: intervals= 1221222; Serial.println("LOCRIAN"); clearscreen2(); lcd.print("LOCRIAN"); break;
          case 32: intervals= 1312131; Serial.println("HUNGARIAN"); clearscreen2(); lcd.print("HUNGARIAN"); break;
          case 34: intervals= 2212221; Serial.println("IONIAN"); clearscreen2(); lcd.print("IONIAN"); break;
      }
    } 
    aLastState = aState; 
  }
  MODE=counter;
  Serial.println(MODE);
 
  intervalsCopie=intervals;   // Se calculeaza, pe baza celor alese de utilizator, notele ce urmeaza a fi cantate (pe o raza de 3 octave)
  notes[1]= baseNote;
  for (n=2; n<=29; n++) {
    st=intervals%10;
    intervals=intervals/10;
    notes[n]=baseNote + st;
    baseNote=notes[n];
    if (n==8 || n==15 || n==22)
      intervals=intervalsCopie;
  }
  lcd.clear();
  delay(1000);
  lcd.setCursor(3, 0);
  lcd.print("HAVE FUN!");
  delay(1000);

  talkMIDI(0xB0, 0, 0x79);
  talkMIDI(0xC0, 1, 0); 
}
void loop() {
  
  digitalWrite(trigPin, LOW);
    delay(10);
    digitalWrite(trigPin, HIGH);
    delay(10);
    digitalWrite(trigPin, LOW);
    duration = pulseIn(echoPin, HIGH);
    distance= duration*0.034/2;
  freq=notes[map(distance, 1, 80, 1, 29)];  // Distanta masurata de senzorul ultrasonic este interpretata si transformata in note muzicale!
     noteOn(0, freq, 60);
  Serial.println(distance);
  freqcopy = freq;
  while (freqcopy == freq) {
    digitalWrite(trigPin, LOW);
    delay(10);
    digitalWrite(trigPin, HIGH);
    delay(10);
    digitalWrite(trigPin, LOW);
    duration = pulseIn(echoPin, HIGH);
    distance= duration*0.034/2;
  freq=notes[map(distance, 1, 80, 1, 29)];
  }
  delay(250);

 }
 
 // Mai jos sunt functiile prestabilite pentru buna functionare a shield-ului Sparkfun Musical Instrument
 
 void noteOn(byte channel, byte note, byte attack_velocity) {
  talkMIDI( (0x90 | channel), note, attack_velocity);
}

//Send a MIDI note-off message.  Like releasing a piano key
void noteOff(byte channel, byte note, byte release_velocity) {
  talkMIDI( (0x80 | channel), note, release_velocity);
}

//Plays a MIDI note. Doesn't check to see that cmd is greater than 127, or that data values are less than 127
void talkMIDI(byte cmd, byte data1, byte data2) {
  digitalWrite(ledPin, HIGH);
  mySerial.write(cmd);
  mySerial.write(data1);

  //Some commands only have one data byte. All cmds less than 0xBn have 2 data bytes 
  //(sort of: http://253.ccarh.org/handout/midiprotocol/)
  if( (cmd & 0xF0) <= 0xB0)
    mySerial.write(data2);

  digitalWrite(ledPin, LOW);
}
